<?php
namespace Teknisa\PLA\Modules\Mymenu\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class Mym00102QuestionarioController {
    protected $crudService;
    
	public function __construct($crudService){
	    $this->crudService = $crudService;
	}
	
	public function saveQuestaoAndResposta(DTO\Request $request, DTO\Response $response ){
	    try {
		    $data = (array)$request->getRow();
		    $this->buildParamsNewCode($data['QUESTAO'], 'NRQUESTAO', 'QUESTAO', 10);
		    $questao = $this->buildValidData($data['QUESTAO'], 'Row', 'questao'); //ROW
			$this->crudService->save('questao', $questao);
		    $nrquestao = $this->crudService->getColumnsToReturn()[0]['NRQUESTAO'];
		    foreach ($data['RESPOSTAS'] as &$resposta) {
		    	$this->buildParamsNewCode($resposta, 'NRRESPOSTA', 'RESPOSTA', 10);
		     	$resposta['NRQUESTAO'] = $nrquestao;
		    }
		    $respostas = $this->buildValidData($data['RESPOSTAS'], 'DataSet', 'resposta'); //ARRAY
			$this->crudService->save('resposta', $respostas);
			$response->addDataset(new DataSet('columnsToReturn', $this->crudService->getColumnsToReturn()));
	    } catch(\Exception $e){
	    	$response->setError(new Error($e->getMessage(), 500));
	    }
	}
	private function buildParamsNewCode(&$row, $tablePk, $newCodePk, $newCodeLength){
	    $row['__is_new_code'] = true;
	    $row['__new_code_pk'] = $newCodePk;
	    $row['__table_pk'] = $tablePk;
	    $row['__new_code_length'] = $newCodeLength;
	    $row['__columns_to_return'] = ['NRQUESTAO'];
	}

	private function buildValidData($data, $type, $dataSourceName){
	    if($type === "Row"){
	        $data = array($data);
	    }
	    
	    $newDataSet = new DataSet($dataSourceName, $data);
	    $newRequest = new DTO\Request\DataSet($newDataSet, '','','','');
	    $returnData = $this->crudService->getRowsToSave($newRequest, $dataSourceName);
	    return $returnData;
	}

}
