<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class NutrientesPorProdutoReport extends \Zeedhi\Framework\Controller\Report {

    protected $reportService;
    protected $qr2Strategy;
    protected $util;
    protected $environment;
    protected $crudService;
    protected $nrlista;

    public function __construct($reportService, $qr2Strategy, $util, $environment, $crudService) {
    	$this->reportService = $reportService;
        $this->qr2Strategy = $qr2Strategy;
        $this->util = $util;
        $this->environment = $environment;
    	$this->crudService = $crudService;
    }

    protected $reportMapping = array (
        'GER04000' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        "NIVEL"        => "P_NIVEL",
                        "PRODINI"      => "P_PRODINI",
                        "PRODFIN"      => "P_PRODFIM",
                        "CD_NUTRIENTE" => "P_CDNUTRIENTE",
                        "ORDENA"       => "P_ORDENA"
                    )
            ),
        'GER04001' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        "NIVEL"        => "P_NIVEL",
                        "PRODINI"      => "P_PRODINI",
                        "PRODFIN"      => "P_PRODFIM",
                        "CD_NUTRIENTE" => "P_CDNUTRIENTE",
                        "ORDENA"       => "P_ORDENA"
                    )
            ),
        'GER04002' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        "NIVEL"        => "P_NIVEL",
                        "PRODINI"      => "P_PRODINI",
                        "PRODFIN"      => "P_PRODFIM",
                        "CD_NUTRIENTE" => "P_CDNUTRIENTE",
                        "ORDENA"       => "P_ORDENA"
                    )
            )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    	$row = $request->getRow();
    	$this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }
    
    
    
    
    
    
}