<?php

namespace Teknisa\PLA\Modules\Transportadas\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\Report\ReportService;

class Pla04100Relatorios extends \Zeedhi\Framework\Controller\Report {

    protected $util;
    protected $environment;
    protected $birtStrategy;
    protected $connection;

    public function __construct(ReportService $reportService, \PLA\Util\Util $util, $environment, $birtStrategy, $connection) {
        $this->reportService = $reportService;
        $this->util = $util;
        $this->environment = $environment;
        $this->birtStrategy = $birtStrategy;
        $this->connection    = $connection;
    }

	protected $reportMapping = array (
        'PLA04100' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04101' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04102' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04103' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04104' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04105' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04106' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04107' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA04108' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA0410A' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        ),
        'PLA0410B' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE"
            )
        )
	);

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $positions = '';

        if ($row['ALLCDFILIAL'] == 'Y' || $row['ALLCDFILIAL'] == 'S') $row['CDFILIAL'] = 'T';
        else $row['CDFILIAL'] = join('_', $row['NMFILIAL']);
        
        if (isset($row['NMGRUPSERV'])) $row['NMGRUPSERV'] = join('_', $row['NMGRUPSERV']);
        else $row['NMGRUPSERV'] = 'T';
        
        if ($row['ALLCDSERVFILI'] == 'Y' || $row['ALLCDSERVFILI'] == 'S') {
            $filiServ = $this->returnFiliServ($row['NMGRUPSERV'], $row['CDFILIAL']);
            foreach ($filiServ as $rowsFiliServ) {
                $positions .= $rowsFiliServ['FILISERV'] . ' ';
            }
            $arrayPositions = explode(' ', $positions);
            array_pop($arrayPositions);
            $row['LISTASERV'] = $this->util->insertLista($arrayPositions);
        } else $row['LISTASERV'] = $this->util->insertLista($row['NMSERVFILI']);
        
        $row["NRORG"] = $this->environment->getNrOrg();
        $row['DTINICIAL'] = $row['DTINTERVAL']['start'];
        $row['DTFINAL'] = $row['DTINTERVAL']['end'];
        
        if ($row['IDORDEMGRUPSERV'] == 'Y') $row['IDORDEMGRUPSERV'] = 'S';
        else $row['IDORDEMGRUPSERV'] = 'N';
        
        if (isset($row['CDPRATOINI'])) $row['CDPRATOINI'] = $row['CDPRATOINI'] ? $row['CDPRATOINI'] : '0';
        else $row['CDPRATOINI'] = '0';
       
        if (isset($row['CDPRATOFIN'])) $row['CDPRATOFIN'] = $row['CDPRATOFIN'] ? str_pad($row['CDPRATOFIN'], 10, 'z', STR_PAD_RIGHT) : 'zzzzzzzzzz';
        else $row['CDPRATOFIN'] = 'Z';
        
        $row['MASKPLATE'] = str_replace('*', '@', $row['MASKPLATE']);
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
    
    public function returnFiliServ($grupServ, $filial) {
        $filiServConcat = [];
    	$sql = "SELECT SUBSTR(SE.CDFILIAL || SE.CDSERVFILI, 1, 9) AS FILISERV FROM SERVICO SE LEFT JOIN ROTATRANS RO ON SE.CDROTATRANS = RO.CDROTATRANS INNER JOIN FILIAL FL ON SE.CDFILIAL = FL.CDFILIAL WHERE ((INSTR(:P_CDFILIAL, SE.CDFILIAL) <> 0) OR (:P_CDFILIAL  = 'T')) AND ((INSTR(:P_CDGRUPSERV, SE.CDGRUPSERV) <> 0) OR (:P_CDGRUPSERV = 'T')) AND (SE.IDTIPOSERV <> 'A')   AND (SE.IDSERVTRAN = 'S') ORDER BY SE.CDFILIAL, SE.CDSERVFILI";
	
		$params = array(
			"P_CDFILIAL"   => $filial,
			"P_CDGRUPSERV" => $grupServ
		);
		
		$stmt = $this->connection->prepare($sql);
		$stmt->execute($params);
    	$result = $stmt->fetchAll();
		return $result;
    }
    
}